package controllers_pages

import (
	"main/mvc/models"
	"main/mvc/models/models_pages"
	"net/http"
)

// Обработчик главной страницы
func PostPageHandler(app *models.App) http.HandlerFunc {
	return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		var err error

		// Страничка рендерится только если ее нет в кэше
		pageData, ok := app.PagesCache.Get(r.URL.Path)
		if !ok {

			post := app.Posts[models_pages.PostLink(r.URL.Path)]

			pageData, err = models_pages.RenderPostPage(app.Templates, app.Version, post.Data)
			if err != nil {
				http.Error(w, err.Error(), http.StatusInternalServerError)
				return
			}
			app.PagesCache.Set(r.URL.Path, pageData)
		}

		sendPostPage(w, pageData.([]byte))
	})
}

// Отправляет страницу
func sendPostPage(w http.ResponseWriter, data []byte) {
	w.Header().Set("Content-Type", "text/html; charset=utf-8")
	w.WriteHeader(http.StatusOK)
	w.Write(data)
}
